

///////////////// Texture \\\\\\\\\\\\\\\
#declare skin_tex = texture { pigment { color rgb <1, 218/255, 210/255> } finish { lego_finish } }
#declare t_purple_tex = texture { pigment { color t_purple filter 1 } finish { t_lego_finish } }




/* //////////////// CSG \\\\\\\\\\\\\\\
eye1(eyec)
eye(eyec)
head_fem01(eyec,age)
hair_fem_short(color_tex)
hair_fem_long(color_tex)
slopeN4_2(color_tex)
h_cover1_1(color_tex)
h_cover1_4(color_tex)*/
  ////////////  \\\\\\\\\\\\\\\\\\\

#macro eye1(eyec)
  difference {
    cylinder { -10*z, 0*z, 0.5 }
    
    cylinder { -10*z, 0*z, 0.2 translate <.25,.25, 0> }
    cylinder { -10*z, 0*z, 0.2 translate <.25,-.25, 0> }
    cylinder { -10*z, 0*z, 0.2 translate <-.25,.25, 0> }
    cylinder { -10*z, 0*z, 0.2 translate <-.25,-.25, 0> }
}
#end
#macro eye(eyec)
  difference {
    cylinder { -10*z, 0*z, 0.5 }
    
    cylinder { -10*z, 0*z, 0.2 translate <.25,.27, 0> scale <1.5,1,1> }
    cylinder { -10*z, 0*z, 0.2 translate <.25,-.27, 0> scale <1.5,1,1> }
    cylinder { -10*z, 0*z, 0.2 translate <-.25,.27, 0> scale <1.5,1,1> }
    cylinder { -10*z, 0*z, 0.2 translate <-.25,-.27, 0> scale <1.5,1,1> }
}
#end
        
#macro head_fem01(eyec,age)
  merge {

    object { head(skin_tex,1) } // <1, 218/255, 210/255>
    
    difference {
      merge {
        //cylinder { -10*z, 0*z, 0.5 translate <-1.4, 5.6, 0> }
        //cylinder { -10*z, 0*z, 0.5 translate <1.4, 5.6, 0> }
        
        object { eye(eyec) translate <-1.4, 5.6, 0> }
        object { eye(eyec) translate <1.4, 5.6, 0> }
        
      }
      difference {
        box { <-20, 0, -20> <20, 11, 20> }
        cylinder { 0*y, 11*y, 5.00005 }
      }
      cylinder { 0*y, 11*y, 3 }
      texture { pigment { color rgb eyec } finish { lego_finish } }
    }
    
    
    difference {
    merge {
      difference {
          cylinder { -10*z, 0*z, 3.4 }
          cylinder { -11*z, 1*z, 3 }
          box { <0, -10, -11> <10, 10, 1> rotate 25*z }
          box { <-10, -10, -11> <0, 10, 1> rotate -25*z }
          translate <0, 6.6, 0>
      }
      cylinder { -10*z, 0*z, 0.2 translate <0, -3.2, 0> rotate 25*z translate <0, 6.6, 0> }
      cylinder { -10*z, 0*z, 0.2 translate <0, -3.2, 0> rotate -25*z translate <0, 6.6, 0> }
    }
      difference {
        box { <-20, 0, -20> <20, 11, 20> }
        cylinder { 0*y, 11*y, 5.00005 }
      }
      cylinder { 0*y, 11*y, 3 }
      texture { red_tex }
    
    }    
        
  }
#end
#macro hair_fem_short(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 0, 0> 1 scale <6, 4.5, 6> }
      translate <0, 2, 0>
      texture { color_tex }
    }
  #else
    merge {
              difference {
                        merge {
                          cylinder { -6*y, 2*y, 5.5 }
                          sphere { <0, 0, 0> 1 scale <6, 4.5, 6> translate <0, 2, 0> }
                          torus { 5.56, .5 translate <0,0,0> }
                        }
                        difference {
                          box { <-10, -10, -4> <0, 4, 4> }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 6> translate <0, 0, -5> rotate 7.5*x translate <-2.5, 3.5, 6> }
                        }
                        difference {
                          box { <-5, -10, -9> <0, 4, 9> }
                          cylinder { -10*z, 10*z, 1 scale <1, 1.75, 1> }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 6> translate <0, 0, -5> rotate 5*x translate <-0.5, 3.1, 6> }
                          box { <-1, 0, -10> <5, 5, 10> }
                          translate <-2, 0.4, 0>
                        }
                        box { <-10, -20, -10> <10, 0, 10> rotate -12*z translate <0, -3, 0> }
                        #if (setting > 1)
                          cylinder { -10*y, 2.1000001*y, 5 }
                          cone { 1.999999*y, 5, 4*y, 3 }
                          cylinder { -10*z, 10*z, 1.5 translate <0.5, -1, 0,> }
                        #end
                        box { <-1.000001, -10, -10> <1.75, -0.999999, 10> }
                        difference {
                          box { <-2, -3, -10> <1, -1, 10> }
                          cylinder { -9*z, 9*z, 1 translate <-2, -1, 0> }
                        }
                        translate <0, 5.2, 0>
              }
              #if (setting > 1)
                object { ring() translate <0, 3, 0> }
              #end
              texture { color_tex }
              bounded_by { box { <-10, -9.25, -6.25> <6.25, 14.25, 6.25> } }
              matrix <1,0,0,0,1,0,0,0,-1,0,0,0>
    }
  #end
#end
#macro hair_fem_long(color_tex)
  #if (setting = 0)
    merge {
      sphere { <0, 0, 0> 1 scale <6, 4.5, 6> }
      translate <0, 2, 0>
      texture { color_tex }
    }
  #else
    merge {
              difference {
                        merge {
                          cylinder { y*-8, 2*y, 5.6 }
                          sphere { <0, 0, 0> 1 scale <6, 4.5, 6> translate <0, 2, 0> }
                          torus { 5.56, .5 translate <0,0,0> }
                          torus { 6, .8 translate <0,-3.7,0> }
                        }
                        torus { 5.7, .5 translate <0,-3.5,0> }
                        difference {
                          box { <-10, -10, -4> <0, 4, 4> }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 6> translate <0, 0, -5> rotate 7.5*x translate <-2.5, 3.5, 6> }
                        }
                        difference {
                          box { <-5, -10, -9> <0, 4, 9> }
                          cylinder { -10*z, 10*z, 1 scale <1, 1.75, 1> }
                          sphere { <0, 0, 0> 1 scale <5, 3.5, 6> translate <0, 0, -5> rotate 5*x translate <-0.5, 3.1, 6> }
                          box { <-1, 0, -10> <5, 5, 10> }
                          translate <-2, 0.4, 0>
                        }
                       box { <-10, -20, -10> <10, 0, 10> rotate -12*z translate <0, -5, 0> }
                       // #if (setting > 1)
                       //   cylinder { -10*y, 2.1000001*y, 5 }
                       //   cone { 1.999999*y, 5, 4*y, 3 }
                       //   cylinder { -10*z, 10*z, 1.5 translate <0.5, -1, 0,> }
                       // #end
                        //box { <-1.000001, -10, -10> <1.75, -0.999999, 10> }
                       // difference {
                        //  box { <-2, -3, -10> <1, -1, 10> }
                       //   cylinder { -9*z, 9*z, 1 translate <-2, -1, 0> }
                       // }
                        translate <0, 5.2, 0>
              }
              #if (setting > 1)
                object { ring() translate <0, 3, 0> }
              #end
              texture { color_tex }
              bounded_by { box { <-10, -14.25, -6.25> <6.25, 14.25, 6.25> } }
              matrix <1,0,0,0,1,0,0,0,-1,0,0,0>
    }
  #end
#end
#macro slopeN4_2(color_tex)
  #if (setting = 0)
    difference {
      box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
      box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 9.5, 0> }
      texture { color_tex }
      rotate y*90 translate z*8
    }
  #else
    merge {
      difference {
        merge {
          difference {
            box { <-3.9, 0, -3.9> <11.9, 9.5, 27.9> }
            box { <-20, 0, -10> <20, 20, 30> texture { color_tex normal { bumping } }
              rotate 43.5*z translate <4, 9.5, 0> }
          }
          #if (setting < 3)
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 0> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 8> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 16> }
            cylinder { 9.4*y, 11.2*y, 2.4 translate <8, 0, 24> }
          #else
            object { rounded_button() rotate 90*y translate <8, 6.4, 0> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 8> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 16> }
            object { rounded_button() rotate 90*y translate <8, 6.4, 24> }
          #end
        }
        #if (setting > 1)
          difference {
            box { <-2.4, -1, -2.4> <10.4, 8.6, 26.4> }
            box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
          }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 0> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 8> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 16> }
          cylinder { 7.4*y, 10.4*y, 1.2 translate <8, 0, 24> }
        #end
      }
      #if (setting > 1)
        difference {
          object { high_ring() translate <4, 0, 4> }
          object { high_ring() translate <4, 0, 12> }
          object { high_ring() translate <4, 0, 20> }
          box { <-20, 0, -10> <20, 20, 30> rotate 43.5*z translate <4, 7.5, 0> }
        }
      #end
      texture { color_tex }
      bounded_by { box { <-4, -0.1, -4> <12, 11.3, 28> } }
      rotate y*90 translate z*8
    }
  #end
#end
             // these are called ffblock in legolib
#macro h_cover1_4(color_tex)
   object {
     box { <-3.9, 0, -3.9> <27.9, 9.5/3, 3.9> }
        texture { color_tex }
       // bounded_by { box { <-4, -0.1, -4> <28, 9.6/3, 4> } }
   }
#end
#macro h_cover1_1(color_tex)
   object {
     box { <-3.9, 0, -3.9> <3.9, 9.5/3, 3.9> }
        texture { color_tex }
       // bounded_by { box { <-4, -0.1, -4> <4, 9.6/3, 4> } }
   }
#end



#macro hrblock1_1_ph(color_tex)
  #if (setting = 0)
    cylinder { 0*y, 9.5*y, 3.9 texture { color_tex } }
  #else
    difference {
      merge {
        #if (setting < 3)
          cylinder { 9.4*y, 11.2*y, 2.4 }
        #else
          object { open_rounded_button() translate <0, 6.4, 0> }
        #end
        cylinder { 2*y, 9.5*y, 3.9 }
        cylinder { 0*y, 2.5*y, 3.15 }
      }
      cylinder { -0.4*y, 8.6*y, 2.5 }
      cylinder { 2*y, 12*y, 1.60001 }
      //
      #if (Use_Photons) Mater(<.08,.5,.09>)
      #else texture { t_dark_green_tex }
      #end
      bounded_by { box { <-4, -0.1, -4> <4, 11.3, 4> } }
    }
  #end
#end

#macro f_block1_1_ph(color_tex)
  #if (setting = 0)
    box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> texture { color_tex } }
  #else
    difference {
      merge {
        box { <-3.9, 0, -3.9> <3.9, 3.1, 3.9> }
        #if (setting < 3)
          cylinder { 3*y, 4.8*y, 2.4 }
        #else
          object { rounded_button() }
        #end
      }
      #if (setting > 1)
        box { <-2.4, -1, -2.4> <2.4, 2, 2.4> }
        cylinder { 1*y, 4*y, 1.2 }
      #end
      //texture { color_tex }
      
      //
      #if (Use_Photons) Mater(<.55,.08,.09>)
      #else texture { t_red_tex }
      #end
      bounded_by { box { <-4, -0.1, -4> <4, 4.9, 4> } }
    }
  #end
#end