// Persistence of Vision RayTracer version 3.1 Scene description file
// File:        REFERENCE_IMAGE.POV
// Description: An empty scene for displaying the different reference images.
// Date:        2007/11/30
// Author:      Anton Raves

// This scene has been developed at a 16 x 9 aspect ratio and should therefore
// be rendered at such an output ratio too! For example you could use 640 x 360.

#declare Final_town    = 1;
#declare Preview_town  = 4;

#declare Quality = Final_town;
#declare radio = 1;
#declare setting = 4;

#include "material.lib"
#include "library.lib"

camera {
  location  <15, 200, -300>
  direction 2*z
  up        y
  right     hdtv*x
  look_at   <15, 20, 0>
  rotate    1*z
}

#switch ( Quality )
  #case ( Final_town )
    light_source { <1650, 1650, 0> color white area_light 50*y, 50*z, 5, 5 adaptive 0 jitter rotate 45*y }
    #declare nice = color white;
    #declare nice2 = color rgb <.2, .2 ,.8>;
    #declare grad_tex =
    texture {
      pigment { gradient y color_map { [ 0.0 color nice ] [ 0.6 color nice2 ] } }
      finish { basic_finish }
      scale 200
    }
    #break
  #case ( Preview_town )
    light_source { <1650, 1650, 0> color white media_interaction off rotate 45*y }
    #declare nice = color white;
    #declare nice2 = color rgb <.2, .2, .8>;
    #declare grad_tex =
    texture {
      pigment { gradient y color_map { [ 0.0 color white ] [ 0.6 color nice2 ] } }
      finish { basic_finish }
      scale 200
    }
#end

union {
  cylinder { -1000*x, 1000*x, 1 texture { orange_bright_tex } no_shadow translate <0, 15, 0> }
  cylinder { -1000*z, 1000*z, 1 texture { orange_bright_tex } no_shadow translate <0, 15, 0> }
  cylinder { -1000*y, 1000*y, 1 texture { orange_bright_tex } no_shadow }
  rotate -25*y
}

#if ( Quality < 7 )
  // the "enclosing world", which makes radiosity work better and more beautiful
  box { <-1000, -122, -1000> <1000, -120, 1000> texture { pigment { color nice } } finish { basic_finish } }
  box { <-1750, -101, -1750> <1750, 1750, 1850> hollow
    texture { pigment { color white } } finish { basic_finish } }
#end

// Replace the object found here below with the one you want.
object { train_cabin_new(yellow_tex) interior { ior 1.5 } scale <2.5, 2.5, 2.5> rotate -25*y translate <0, 15, 0> }
